#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;

use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use pseek;
use fmspm;

&get_setup;
fmspm::check_spamb("rss.cgi", "header", "$data_dir");
$q = CGI->new;

################# 

$cid = $q->param('c');

if (($cid ne "new") and ($cid ne "pop")) {$cid =~ s/[^0-9]//g;}

$gsettings = new_gsettings;

$rssmain = pseek::get_file_contents("$data_dir/rss.conf");	
@rssitems = split (/o--:--:--o/, $rssmain);

$rss_img  = $rssitems[0];
$mainrss  = $rssitems[1];
$rssitems = $rssitems[2];	
$limitnr  = $rssitems[3];

$rss_channel_new = $rssitems[4];
$rss_channel_title_new = $rssitems[5];
$rss_channel_diz_new = $rssitems[6];

$rss_channel_pop = $rssitems[7];
$rss_channel_title_pop = $rssitems[8];
$rss_channel_diz_pop = $rssitems[9];

if ($rss_channel_new eq "") { $rss_channel_new = "New Listings"; }
if ($rss_channel_title_new eq "") { $rss_channel_title_new = "New Listings"; }
if ($rss_channel_diz_new eq "") { $rss_channel_diz_new = "New Listings"; }

if ($rss_channel_pop eq "") { $rss_channel_pop = "Popular Listings"; }
if ($rss_channel_title_pop eq "") { $rss_channel_title_pop = "Popular Listings"; }
if ($rss_channel_diz_pop eq "") { $rss_channel_diz_pop = "Popular Listings"; }


if ($limitnr eq "") { $limitnr = "50"; }
if ($limitnr > 0) { $limitsql = "LIMIT 0, $limitnr"; }



if ($mainrss eq "")
{
$mainrss = qq[<?xml version="1.0" encoding="iso-8859-1" ?>
<rss version="2.0">
   <channel>
      <title>!!channel_category!!</title>
      <link>!!pagelink!!</link>
      <description>!!channel_description!!</description>
      <language>en-us</language>
      <pubDate>!!pubdate!!</pubDate>
      <lastBuildDate>!!pubdate!!</lastBuildDate>
      <generator>PowerSeek 3</generator>
      !!itemshere!!
   </channel>
</rss>
];
}

if ($rssitems eq "")
{
$rssitems = qq[<item>
<title>!!title!!</title>
<link>!!more_info!!</link>
<description>!!description!!</description>
<pubDate>!!pubdate!!</pubDate>
<guid>!!more_info!!</guid>
</item>
];
}


@day_of_week = ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
@months = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


if (($cid eq "new") or ($cid eq "pop"))
	{
	
	if ($cid eq "new")
		{
		$channel_category = $rss_channel_new;
		$channel_title = $rss_channel_title_new;
		$channel_description = $rss_channel_diz_new;
		$newpoplink = "new";
		}
		else
		{
		$channel_category = $rss_channel_pop;
		$channel_title = $rss_channel_title_pop;
		$channel_description = $rss_channel_diz_pop;	
		$newpoplink = "pop";
		}
	
	
		if ($gsettings->{dyn_stat} eq "Static")
			{
			$pagelink = "<![CDATA[$web_url/$newpoplink/]]>";
			}
			else
			{
			$pagelink = "<![CDATA[$script_url/dirs.cgi?newpop=$newpoplink]]>";
			}	

		($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime();
		$weekday = $day_of_week[$wday];
		$monthcurrent = $months[$mon];
		$year = "20" . substr($year, 1, 2);
		if (length($mday) == 1) { $mday = "0" . $mday; }
		if (length($hour) == 1) { $hour = "0" . $hour; }
		if (length($min) == 1) { $min = "0" . $min; }
		if (length($sec) == 1) { $sec = "0" . $sec; }

	$pubdate_main = "$day_of_week[$wday], $mday $monthcurrent $year $hour:$min:$sec GMT";
	}
	else
	{

		$wsql = "SELECT * FROM dirs WHERE cid = '$cid'";
		$sth = $dbh->prepare($wsql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
		$rows = $sth->rows();

		while ( @row = $sth->fetchrow() )
		{
		$channel_category = $row[28];
		$channel_category = "<![CDATA[" . $channel_category . "]]>";
		
		$channel_title = $row[25]; if ($channel_title  eq "") { $channel_title = $channel_category; }
		$channel_title = "<![CDATA[" . $channel_title . "]]>";
		
		$channel_description = $row[18];
		$channel_description = "<![CDATA[" . $channel_description . "]]>";
	
				$cats = ""; $ecat = ""; $rdcat = ""; $lv = 0;
				for ($ms = 2; $ms < 18; $ms++)
					{
					if ($row[$ms] ne "")
						{
						$ecat = $ecat . &encode_dir($row[$ms]) . "-";
						$rdcat = $rdcat . &encode_dir($row[$ms]) . "/";
						$lv++;
						}
					}
				chop($ecat);
	
	
		if ($gsettings->{dyn_stat} eq "Static")
			{
			$pagelink = "<![CDATA[$web_url/$rdcat]]>";
			}
			else
			{
			$pagelink = "<![CDATA[$script_url/dirs.cgi?lv=$lv&ct=$ecat]]>";
			}
	
	
		if ($row[23] > 0)
			{
			($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($row[23]);
			
			$weekday = $day_of_week[$wday];
			$monthcurrent = $months[$mon];
			$year = "20" . substr($year, 1, 2);
			if (length($mday) == 1) { $mday = "0" . $mday; }
			
			if (length($hour) == 1) { $hour = "0" . $hour; }
			if (length($min) == 1) { $min = "0" . $min; }
			if (length($sec) == 1) { $sec = "0" . $sec; }
			
			$pubdate_main = "$day_of_week[$wday], $mday $monthcurrent $year $hour:$min:$sec GMT";
			}
		
		}
}

#print "channel_category = $channel_category <BR>";
#print "channel_title = $channel_title<BR>";
#print "channel_description = $channel_description<BR>";
#print "pagelink = $pagelink<BR>";
#print "pubdate = $pubdate<BR>";



$keydata = pseek::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;


if ($cid eq "new")
	{
	$wsql = "SELECT * FROM links WHERE ((newsubm = '') OR (newsubm IS NULL)) ORDER BY urldate DESC $limitsql";
	}
	elsif ($cid eq "pop")
	{
	$wsql = "SELECT * FROM links WHERE ((newsubm = '') OR (newsubm IS NULL))  ORDER BY votes DESC,hits DESC $limitsql";
	}
	else
	{
	$wsql = "SELECT * FROM links WHERE (cid = '$cid') AND
   ((newsubm = '') OR (newsubm IS NULL)) ORDER BY urldate DESC $limitsql
	";
	}
	
	$sth = $dbh->prepare($wsql);
	$sth->execute;
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $wsql";}
	$rows = $sth->rows();

	while ( @row = $sth->fetchrow() )
	{
	$title = $row[2];
	$title = "<![CDATA[" . $title . "]]>";
	
	$description = $row[3];
	$description = "<![CDATA[" . $description . "]]>";

	$url = $row[5];
	
	if ($gsettings->{dyn_stat} eq "Static")
		{
		$more_info = "<![CDATA[$script_url/rssrd.cgi?id=$row[0]&cid=$row[1]"  . "]]>";
		}
		else
		{
		$more_info = "<![CDATA[$script_url/linfo.cgi?id=$row[0]]]>";
		}	


	($sec,$min,$hour,$mday,$mon,$year,$wday,$ydat,$isdst) = localtime($row[17]);
	
	$weekday = $day_of_week[$wday];
	$monthcurrent = $months[$mon];
	$year = "20" . substr($year, 1, 2);
	if (length($mday) == 1) { $mday = "0" . $mday; }
	
	if (length($hour) == 1) { $hour = "0" . $hour; }
	if (length($min) == 1) { $min = "0" . $min; }
	if (length($sec) == 1) { $sec = "0" . $sec; }

	$pubdate = "$day_of_week[$wday], $mday $monthcurrent $year $hour:$min:$sec GMT";	
	
	$name = $row[8];
	$name = "<![CDATA[" . $name . "]]>";
	
	$email = $row[9];
	$name = "<![CDATA[" . $email . "]]>";


	$tmpfeed = $rssitems;
	$tmpfeed =~ s/!!title!!/$title/gi;
	$tmpfeed =~ s/!!description!!/$description/gi;
	$tmpfeed =~ s/!!url!!/$url/gi;
	$tmpfeed =~ s/!!more_info!!/$more_info/gi;
	$tmpfeed =~ s/!!pubdate!!/$pubdate/gi;
	$tmpfeed =~ s/!!name!!/$name/gi;
	$tmpfeed =~ s/!!email!!/$email/gi;


	#### EXTRA FIELDS/KEYS
	$akey_start = 27;  
	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description1, $na, $imgk) = split (/\t/, $k_item);
		$extra_key_boxes = $extra_key_boxes . qq[<input type="checkbox" name="$kname" value="$kname" checked>$description1<BR>];
		
		
		$keyreplace = "!!" . $keyname . "!!";
		$keyrepl = "<![CDATA[" . $row[$akey_start] . "]]>";
		
		if ($row[$akey_start] ne "")
			{
			$tmpfeed =~ s/$keyreplace/$keyrepl/gi;
			}
			else
			{
			$tmpfeed =~ s/$keyreplace//gi;
			}
		
		$akey_start++;
		}


	$itemsfeed = $itemsfeed . $tmpfeed;
	

#print "<BR>-----------<BR>";
#print "title: $title<BR>";
#print "description: $description<BR>";
#print "url: $url<BR>";
#print "more_info: $more_info<BR>";
#print "pubdate: $pubdate<BR>";
#print "name: $name<BR>";
#print "email: $email<BR>";	
	}
	
$sth->finish;
$dbh->disconnect;


$mainrss =~ s/!!channel_category!!/$channel_category/gi;
$mainrss =~ s/!!channel_title!!/$channel_title/gi;
$mainrss =~ s/!!channel_description!!/$channel_description/gi;

if ($pubdate_main eq "") { $pubdate_main = $pubdate;}
$mainrss =~ s/!!pubdate!!/$pubdate_main/gi;	
$mainrss =~ s/!!pagelink!!/$pagelink/gi;	

$mainrss =~ s/!!itemshere!!/$itemsfeed/gi;

print "Content-Type: text/xml\n\n";
#print "Content-type: text/html\n\n";
print "$mainrss";

################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

